% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab.R
\name{tab_prepare}
\alias{tab_prepare}
\title{Prepare data for \code{\link{tab_plain}}.}
\usage{
tab_prepare(
  data,
  ...,
  na_drop_all,
  cleannames = NULL,
  other_if_less_than = 0,
  other_level = "Others"
)
}
\arguments{
\item{data}{A dataframe.}

\item{...}{Variables then to be passed in \code{\link{tab_plain}}.}

\item{na_drop_all}{<\link[tidyr:tidyr_tidy_select]{tidy-select}> Removes all
observation with a \code{NA} in any of the chosen variables.}

\item{cleannames}{Set to \code{TRUE} to clean levels names, by removing
prefix numbers like \code{"1-"}, and text in parentheses.}

\item{other_if_less_than}{When set to a positive integer, levels with less count
than it will be merged into an "Others" level.}

\item{other_level}{The name of the "Other" level, as a character vector of length one.}
}
\value{
A modified data.frame.
}
\description{
Prepare data for \code{\link{tab_plain}}.
}
\examples{
\donttest{data <- dplyr::starwars \%>\%
tab_prepare(sex, hair_color, gender, other_if_less_than = 5,
            na_drop_all = sex)
data
}
}
